#!/usr/bin/perl -w
# simeline.pl
# David Rowe 31/3/03
# simulates a phone line, rings until phone answers, then starts again 
# when phone hangs up.

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;

sub procargs(@);
sub wait_for_hangup();

my $rings = 0;
my $its = 0;
my $daemon = 0;
my $port = 1201;

procargs(@ARGV);

$ctport = new Telephony::CTPort($port);
if ($daemon) {
	$ctport->daemonize($daemon);
	my $logfile="/tmp/simline-$port.log";
	$ctport->openlogger($logfile);
}
$ctport->start_ring_async();
$ctport->start_timer_async(4);

while (1) {
    ($handle, $event) = $ctport->wait_for_event();
    $ctport->logger("[$handle] $event");

    if ($event eq "pickup") {
	$ctport->stop_timer();

	$ctport->play_tone_async("dial");
	wait_for_hangup();
	$ctport->stop_tone();

	$ctport->start_ring_async();
	$ctport->start_timer_async(4);
	$rings = 0;

	$its++;
	$ctport->logger("calls made $its");
    }

    if ($event eq "timer") {
	$rings++;
	if ($rings == 4) {
	    $ctport->stop_ring();
	}
	else {
	    $ctport->start_ring_async();
	    $ctport->start_timer_async(4);
	}
    }
}

sub wait_for_hangup() {
    while (1) {
	($handle, $event) = $ctport->wait_for_event();
	$ctport->logger("[$handle] $event");

	if ($event eq "hangup") {
	    return;
	}
    }
}

sub procargs(@){
	my $bit;

	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
	}
}


