#!/usr/bin/perl -w
# test006callgen.pl
# David Rowe 7/4/03 and ripped of Ben Kramer on 17/4/03
#

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;

sub procargs(@);

my $pwd="/home/ben/s/ctserver/openpbx/tests";
my $its = 0;
my $tot = 0;
my $daemon = 0;
my $simline;
my $simphone;

procargs(@ARGV);

$simline = new Telephony::CTPort(1203);
$simphone = new Telephony::CTPort(1208);

$simline->set_paths($pwd);

if ($daemon) {
	$simline->daemonize($daemon);
	my $logfile="/tmp/test006.log";
	$simline->openlogger($logfile);
}
$simphone->on_hook();    

while(1) {
	$simline->start_ring_async();
	$simline->logger("ext line ringing, waiting for station A to ring");
	$simphone->wait_for_ring();
	$simphone->off_hook();
	$simline->logger("station A answered");
	sleep(1);
	$simline->play_async("tone.wav");
	$simphone->record("test006-$tot.wav",30,""); 
	$simline->logger("Finshed recording");
	@res=`/usr/bin/sox -t auto $pwd/test006-$tot.wav -u -r 8000 -c 1 -w $pwd/test006b-$tot.wav`;

	@res=`$pwd/tonetrain -e -w $pwd/test006b-$tot.wav `;
	foreach $line (@res){
		if ($line =~ /VPB_TONE/){
			my ($junk,$stuff)=split /=/,$line;
			my ($j,$t,$f,$j2)=split /,/,$stuff;
			$simline->logger("[$stuff]=>$j,$t,$f,$j2");
			#if ($t eq "C") {
				if (($f>400)&&($f<460)){
					$its++;	
					unlink("$pwd/test006b-$tot.wav");
					unlink("$pwd/test006-$tot.wav");
				}
			#}
		}
	}
	$tot++;
	
	$simphone->on_hook();
	$simline->logger("Successfull $its out of $tot");
	unlink("test006.wav");
	sleep(2);
}

sub procargs(@){
	my $bit;
	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
	}
}

