#!/usr/bin/perl -w
# simphone.pl
# David Rowe 31/3/03
# Simulates a telephone, answers ringing line, then hangs up

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;

sub procargs(@);
sub wait_for_hangup();

my $its = 0;
my $port = 1206;
my $daemon = 0;

procargs(@ARGV);

$ctport = new Telephony::CTPort($port);
if ($daemon) {
	$ctport->daemonize($daemon);
	my $logfile="/tmp/simphone-$port.log";
	$ctport->openlogger($logfile);
}
$ctport->on_hook();    

while(1) {
    $ctport->logger("Waiting for ring");
    $ctport->wait_for_ring();
    $ctport->logger("Answering");
    $ctport->off_hook();
    $ctport->logger("off hook");
    sleep(2);
    $ctport->on_hook();    
    $ctport->logger("on hook");
    $its++;
    $ctport->logger("calls answered: $its");
}

sub procargs(@){
	my $bit;

	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
	}
}

