#!/usr/bin/perl -w
# testm2002callgen.pl
#
#	./station.pl -d -p 0 -c tests/testm2002.conf
#	./station.pl -d -p 1 -c tests/testm2002.conf
#	./station.pl -d -p 2 -c tests/testm2002.conf
#	./station.pl -d -p 3 -c tests/testm2002.conf
#
# Star menu tree
#   *+->1+->1+->1
#    |   |   |
#    |   |   +->2
#    |   |
#    |   +->2+->1 
#    |       |
#    |       +->2
#    |
#    +->*

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;
use Data::Dumper;

sub procargs(@);
sub leave_msg($);
sub grope_branch($$);
sub grok_menu($);

my $menutree={
	"*"=>{
		"1"=>{
			"1"=>{"1"=>undef,"2"=>undef,},
			"2"=>{"1"=>undef,"2"=>undef,},
		},
		"*"=>undef,
	},
};

my $daemon = 0;
our $port=1208;

procargs(@ARGV);

$simstat1 = new Telephony::CTPort($port);

$simstat1->on_hook();

if ($daemon) {
	$simstat1->daemonize($daemon);
	my $logfile="/tmp/testm2002callgen-$port";
	$simstat1->openlogger($logfile);
}

my @opts;
my $cont;
my $sel;
my $ref=$menutree;
my $tst;
my $lvl=0;
my $dialled="";
my $tot=0;
while(1) {
	$tot++;
	# Take phone off hook
	$simstat1->off_hook();
	$simstat1->wait_for_dial_tone();
	$simstat1->logger("got dialtone");
	$lvl=0;
	$cont=1;
	$dialled="";
	while ($cont){
		$lvl++;
		@opts=grok_menu($ref);
		$foo=int(rand($#opts+1));
		$sel=$opts[$foo];
		$simstat1->dial($sel);
		$dialled.=$sel." ";
		undef $tst;
		$tst=$ref->{$sel};
		if(defined $tst){
			$ref=$tst;
		}
		else {
			$cont=0;
		}
	}
	$simstat1->on_hook();
	$simstat1->logger("traversed [$lvl] menus with [$dialled] iteration[$tot]");
	$ref=$menutree;
	sleep(1);
}

sub procargs(@){
	my $bit;
	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
		if ($bit =~ /-p/){
			$port=shift @ARGV;
			$port+=1200;
		}
	}
}

sub grope_branch($$){
	my $hash_ref=shift;
	my $level=shift;
	my $i=0;
	my $sp="";
	while ($i++<$level){
		$sp.="  ";
	}
	foreach my $bit (sort {$a cmp $b} (keys %{$hash_ref})){
		my $next_bit=$hash_ref->{$bit};
		print $sp.$bit."\n";
		if (defined $next_bit){
			grope_branch($next_bit,($level+1));
		}
	}
}

sub grok_menu($){
	my $ref=shift;
	my @opts;
	foreach my $bit (sort {$a cmp $b} (keys %{$ref})){
		push @opts,$bit;
	}
	return(@opts);
}
