#!/usr/bin/perl -w
# testm2005grabber.pl
#

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;

sub procargs(@);

my $its = 0;
my $btimeout = 0;
my $daemon = 0;
my $simline;
my $simphoneA;
my $simphoneB;

procargs(@ARGV);

$simline = new Telephony::CTPort(1211);
$simphoneA = new Telephony::CTPort(1206);
$simphoneB = new Telephony::CTPort(1207);

if ($daemon) {
	$simline->daemonize($daemon);
	my $logfile="/tmp/testm2005-grabber-";
	$simline->openlogger($logfile);
}
$simphoneA->on_hook();    
$simphoneB->on_hook();    

while(1) {
	$simline->start_ring_async();
	$simline->logger("ext line ringing, waiting for station A to ring");
	$simphoneA->wait_for_ring();
	$simline->logger("station A is ringing");
	sleep(1);

	# pickup ringing extension
	$simphoneB->off_hook();
	$simphoneB->dial(',**');
	$simline->logger("station B grabed line");

	$simphoneA->off_hook();
	$simphoneA->wait_for_dial_tone();
	$simline->logger("station A got dialtone, confirming B has line");
	$simphoneA->on_hook();
	sleep(2);
	$simphoneB->on_hook();
	$simline->logger("station B back on hook, finished");
	$its++;	
	$simline->logger("calls grabbed [$its]");

}


sub procargs(@){
	my $bit;

	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
	}
}

