#!/usr/bin/perl -w
# testm2005leavemsg-stat.pl
#
#       + leaves many messages

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;


sub procargs(@);
sub leave_msg($);

my $daemon = 0;
my $simtrunk;
my $simstat;
my $collector;
my $totmsgs=0;
my $collmsgs=0;
my $port=1208;

procargs(@ARGV);

$ctport = new Telephony::CTPort($port);

$ctport->on_hook();

if ($daemon) {
	$collector->daemonize($daemon);
	my $logfile="/tmp/testm2005leavemsg-stat-$port-";
	$ctport->openlogger($logfile);
}

while(1) {
	# Leave a message 
	$ctport->logger("Leaving message from stat");
	$ctport->off_hook();
	$ctport->dial("102");
	# wait for greeting to play
	sleep(5);
	leave_msg($ctport);
	$ctport->dial("#");
	$ctport->on_hook();
	$totmsgs++;
	sleep(1);

	# Leave a message 
	$ctport->logger("Leaving message from stat");
	$ctport->off_hook();
	$ctport->dial("103");
	# wait for greeting to play
	sleep(5);
	# leave a message
	leave_msg($ctport);
	$ctport->dial("#");
	$ctport->on_hook();
	$totmsgs++;

	$ctport->logger("Left a total of [$totmsgs] msgs.");
	sleep(2)
}

sub leave_msg($){
	my $line=shift;
	$line->play("1 2 3 4 5 6 7 8 9 10");
	$line->play("1 2 3 4 5 6 7 8 9 10");
}

sub procargs(@){
	my $bit;
	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
		elsif ($bit =~/-p/){
			$port= shift @ARGV;
			$port+=1200;
		}
	}
}

