#!/usr/bin/perl -w
# testm2005leavemsg-trunk.pl
#
#       + leaves many messages

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;


sub procargs(@);
sub leave_msg($);

my $daemon = 0;
my $simtrunk;
my $simstat;
my $collector;
my $totmsgs=0;
my $collmsgs=0;
my $port=1208;

procargs(@ARGV);

$ctport = new Telephony::CTPort($port);


if ($daemon) {
	$collector->daemonize($daemon);
	my $logfile="/tmp/testm2005leavemsg-trunk-$port-";
	$ctport->openlogger($logfile);
}

while(1) {
	# Leave a message 
	$ctport->logger("Leaving message from trunk");
	# ring collector
	$ctport->start_ring_async();
	$waiting=1;
	while ($waiting){
		($handle,$event)=$ctport->wait_for_event();
		if ($event eq "pickup"){
			$ctport->logger("Got pickup");
			$waiting=0;
		}
		else {
			$ctport->logger("Got [$event] while waiting for pickup");
		}
	}
	# wait for greeting to play
	sleep(5);
	$ctport->clear();
	# leave a message
	leave_msg($ctport);
	# wait for hangup
	$ctport->play_busy_tone_async();
	$waiting=1;
	while($waiting){
		($handle,$event)=$ctport->wait_for_event();
		if ($event eq "hangup"){
			$ctport->logger("Got hangup");
			$waiting=0;
		}
		elsif ($event eq "toneend"){
			$ctport->logger("Got [$event] while waiting for hangup");
			$ctport->play_busy_tone_async();
		}
		else {
			$ctport->logger("Got [$event] while waiting for hangup");
		}
	}
	$ctport->play_terminate();
	$totmsgs++;
	$ctport->("Left [$totmsgs] messages");
	sleep(2)
}

sub leave_msg($){
	my $line=shift;
	$line->play("1 2 3 4 5 6 7 8 9 10");
	$line->play("1 2 3 4 5 6 7 8 9 10");
}

sub procargs(@){
	my $bit;
	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
		elsif ($bit =~/-p/){
			$port= shift @ARGV;
			$port+=1200;
		}
	}
}

