#!/usr/bin/perl -w
# testm2005transfer.pl

BEGIN {
  push(@INC, "../../CTPort");
};

use CTPort;
use POSIX;
use IO::Handle;

sub procargs(@);
sub wait_for_ring_simphoneB();

my $its = 0;
my $btimeout = 0;
my $daemon = 0;
my $simline;
my $simphoneA;
my $simphoneB;

procargs(@ARGV);

$simline = new Telephony::CTPort(1210);
$simphoneA = new Telephony::CTPort(1204);
$simphoneB = new Telephony::CTPort(1205);

if ($daemon) {
	$simline->daemonize($daemon);
	my $logfile="/tmp/testm2003";
	$simline->openlogger($logfile);
}
$simphoneA->on_hook();    
$simphoneB->on_hook();    

while(1) {
	$simline->logger("NORMAL transfer");
	$simline->start_ring_async();
	$simline->logger("ext line ringing, waiting for station A to ring");
	$simphoneA->wait_for_ring();
	$simphoneA->off_hook();
	$simline->logger("station A answered");
	sleep(1);

	# A transfer to B
	$simphoneA->dial(',&');
	$simline->logger("flashed A, waiting for dial tone");

	$simphoneA->wait_for_dial_tone();
	$simline->logger("OK, got dial tone, dialling station B");
	$simphoneA->dial('105');
	$simline->logger("waiting for station B to ring");
	#$simphoneB->wait_for_ring();
	wait_for_ring_simphoneB();
	$simphoneB->off_hook();
	$simline->logger("OK, station B answered");
	$simphoneA->on_hook();
	
	sleep(2);
	$simphoneB->on_hook();
	$simline->logger("station B back on hook, finished");
	$its++;	
	$simline->logger("calls answered and transferred: $its" .
			 " b timeouts: $btimeout");

	$simline->logger("BLIND transfer");
	$simline->start_ring_async();
	$simline->logger("ext line ringing, waiting for station A to ring");
	$simphoneA->wait_for_ring();
	$simphoneA->off_hook();
	$simline->logger("station A answered");
	sleep(1);

	# A transfer to B
	$simphoneA->dial(',&');
	$simline->logger("flashed A, waiting for dial tone");

	$simphoneA->wait_for_dial_tone();
	$simline->logger("OK, got dial tone, dialling station B");
	$simphoneA->dial('105');
	$simline->logger("waiting for station B to ring");
	#$simphoneB->wait_for_ring();
	wait_for_ring_simphoneB();
	$simphoneA->on_hook();
	sleep(1);
	$simphoneB->off_hook();
	$simline->logger("OK, station B answered");
	
	sleep(2);
	$simphoneB->on_hook();
	$simline->logger("station B back on hook, finished");
	$its++;	
	$simline->logger("calls answered and transferred: $its" .
			 " b timeouts: $btimeout");

	$simline->logger("VMAIL transfer");
	$simline->start_ring_async();
	$simline->logger("ext line ringing, waiting for station A to ring");
	$simphoneA->wait_for_ring();
	$simphoneA->off_hook();
	$simline->logger("station A answered");
	sleep(1);

	# A transfer to B
	$simphoneA->dial(',&');
	$simline->logger("flashed A, waiting for dial tone");

	$simphoneA->wait_for_dial_tone();
	$simline->logger("OK, got dial tone, dialling station B");
	$simphoneB->off_hook();
	$simphoneA->dial('105');
	$simphoneA->on_hook();
	sleep(1);
	$simphoneB->on_hook();
	$simline->play_busy_tone_async();
	sleep(6);
	$simline->play_terminate();

	
	$its++;	
	$simline->logger("calls answered and transferred: $its" .
			 " b timeouts: $btimeout");
}

# this sub used to time out if we dont get ring after 10 seconds
# due to very rare case when DTMF gets missed

sub wait_for_ring_simphoneB() {

	$simphoneB->start_timer_async(10);
	while (1) {
		($handle, $event) = $simphoneB->wait_for_event();
		$simline->logger("[$handle] $event");

		if ($event eq "ring") {
			$simphoneB->stop_timer();
			return;
		}
		if ($event eq "timer") {
			$simline->logger("TIMEOUT: NO RING ON STATION B");
			$btimeout++;
			return;
		}
	}
}

sub procargs(@){
	my $bit;

	while($bit = shift @ARGV){
		if ($bit =~ /-d/){
			$daemon = 1;
		}
	}
}

