#!/usr/bin/perl -w

use CGI;
use Data::Dumper;

my $pbxconf="../../pbx.conf";
my $loglocation="../../log";
my $config;

sub getconf($);
sub writeconf($$);
sub doerr($);

my $q=new CGI;

my $titles={
	"moh" => "MUSIC ON HOLD",
	"dialmap" => "DIAL PLAN",
	"ports" => "PORT CONFIG",
	"trunkmap" => "TRUNK MAP",
	};
my $coltitles={
	"moh" => { "left" => "", "right" => "Music on hold files",},
	"dialmap" => { "left" => "Extension Number", "right" => "Port Number",},
	"ports" => { "left" => "Port Number", "right" => "Type of Port",},
	"trunkmap" => { "left" => "Trunk Port Number", "right" => "Extension Number(s)",},
	};
my $instructions={
	"moh" => "This is a list of files that will played back during music on hold. 'Path to Files' is the full path to the directory that contains the files, else it defaults to using the system directory.<br>",
	"dialmap" => "In the left column, is the number that you would dial to get an extension. In the right column is the physical port number on the OpenSwitch card.<br>",
	"ports" => "In the left column is the physical port number on the OpenSwitch card and on the right is what that port is configured as.<br>",
	"trunkmap" => "In the left column is the physical port number of a trunk. In the right column is the extension number that you wish to map that trunk to.<br> You can have a comma seperated list (like 1,2,3,4) to implement a hunt group.<br>",
	};
my $taglist={
	"dialmap" => ",1,2,3,4,5,6,7,8",
	"ports" => ",0,1,2,3,4,5,6,7,8,9,10,11",
	"trunkmap" => ",8,9,10,11",
	};

my $vallist={
	"dialmap" => ",0,1,2,3,4,5,6,7",
	"ports" => ",station,trunk",
	"trunkmap" => ",1,2,3,4",
	};

print $q->header;
#print Dumper($config);
print $q->start_html;
print <<EOM;
<style type="text/css">
<!--
\@import url(../voicetronix.css);
-->
</style>
EOM

print $q->start_form(-onsubmit=>"return check_new(this)");
my %vars=$q->Vars;
#print "<pre>".Dumper(%vars)."</pre>";
if (defined $vars{"submited"}){
	# find the sections!
	my $x=0;
	while ($x < 10){
		$x++;
		my $sect="section".$x;
		if (defined $vars{"$sect"}){
			my $msect=$vars{$sect};
			my $y=0;
			while ($y<50){
				$y++;
				my $tag="T$msect$y";
				my $val="V$msect$y";
				if (defined $vars{$tag}){
					my $mtag=$vars{$tag};
					if (($mtag ne "")&&($vars{$val} ne "")){
						$config->{$msect}->{$mtag}=$vars{$val};
					}
				}
			}

		}
	}
#	foreach my $tag (keys %vars){
#		print "$tag -> $vars{$tag} <br>\n";
#	}
	writeconf($pbxconf,$config);
}
else {
	$config=getconf($pbxconf);
#	print "<pre>".Dumper($config)."</pre>";
}
print "<div align=left valign=top class=\"Text\">\n";
print "<table border=0 class=\"Text\" width=\"611\">\n";
print "<input type=hidden name=\"submited\" value=1>\n";
print "<input type=hidden name=\"sect\" value=\"$vars{sect}\">\n";
my $sectcnt=0;
foreach $section (keys %{$config}){
	$sectcnt++;
	my $title=$titles->{$section};
	my $tvcnt=0;
	if ($vars{sect} eq $section){
#		print "<tr><td  bgcolor=\"#F3F3F3\" class=\"TableHeadingText\">$title<input type=hidden name=\"section$sectcnt\" value=\"$section\"></td></tr>\n";
		print "<input type=hidden name=\"section$sectcnt\" value=\"$section\">\n";
		print <<EOM;
<tr><td>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<td width="15" height="26" valign="top" bgcolor="#F3F3F3"><!--DWLayoutEmptyCell-->&nbsp;</td>
		<td width="550" valign="middle" bgcolor="#F3F3F3" class="HeadingText"> <div align="left" class="Text">
		<class="HeadingText"><strong>$title</strong>
		</div></td>
		<td width="18" valign="top" bgcolor="#F3F3F3"><!--DWLayoutEmptyCell-->&nbsp;</td>
		</tr>
	</table>
</td></tr>
EOM
		print "<tr><td >$instructions->{$section}</td></tr>\n";
		print "<tr><td >&nbsp;</td></tr>\n";
		print "<tr><td><table>\n";
		if ($section ne "moh"){
			print "<tr class=\"TableTextAlt\"><td align=right>$coltitles->{$section}{'left'}</td><td>&nbsp;</td><td align=left>$coltitles->{$section}{'right'}</td></tr>\n";
		}
		else {
			$tvcnt++;
			print "<tr class=\"TableTextAlt\" align=center><td align=right>Path to Files &nbsp;"
				."<input type=hidden name=\"T$section$tvcnt\" value=\"path\">"
				."<input type=text name=\"V$section$tvcnt\" value=\"$config->{$section}{'path'}\"></td></tr>\n";
			print "<tr class=\"TableTextAlt\"><td align=center >$coltitles->{$section}{'right'}</td></tr>\n";
			
		}
	}
	else {
		print "<input type=hidden name=\"section$sectcnt\" value=\"$section\">\n";
	}
	foreach $tag (sort {$a <=> $b} (keys %{$config->{$section}})){
		$tvcnt++;
		my $val=$config->{$section}->{$tag};
		if ($vars{"sect"} eq $section){
			print "<tr class=\"TableTextAlt\">";
			if ($section ne "moh"){
				if ($taglist->{$section} eq ""){
					print "<td  align=right><input type=text name=\"T$section$tvcnt\" value=\"$tag\"></td>";
				}
				else {
					print "<td align=right>\n";
					print "<select name=\"T$section$tvcnt\">\n";
					my $selected=0;
					foreach my $bit (split/,/,$taglist->{$section}){
						if ($bit eq $tag){
							print "\t<option value=\"$bit\" selected>$tag</option>\n";
							$selected=1;
						}
						else {
							print "\t<option value=\"$bit\" >$bit</option>\n";
						}
					}
					if (!$selected){
						print "\t<option value=\"$tag\" selected>$tag</option>\n";
					}
					print "</select></td>\n";
					

				}
				print "<td >=</td>";
				if ($vallist->{$section} eq ""){
					print "<td align=left><input type=text name=\"V$section$tvcnt\" value=\"$val\"></td></tr>\n";
				}
				else{
					print "<td align=left>\n";
					print "<select name=\"V$section$tvcnt\">\n";
					my $selected=0;
					foreach my $bit (split/,/,$vallist->{$section}){
						if ($bit eq $val){
							print "\t<option value=\"$bit\" selected>$val</option>\n";
							$selected=1;
						}
						else {
							print "\t<option value=\"$bit\" >$bit</option>\n";
						}
					}
					if (!$selected){
						print "\t<option value=\"$val\" selected>$val</option>\n";
					}
					print "</select></td>\n";
				}
			}
			else {
				if ($tag ne "path"){
					my $mycnt=$tvcnt-1;
					print "<input type=hidden name=\"T$section$tvcnt\" value=\"moh$mycnt\">";
					print "<td align=center ><input type=text name=\"V$section$tvcnt\" value=\"$val\"></td></tr>\n";
				}
			}
		}
		else {
			print "<input type=hidden name=\"T$section$tvcnt\" value=\"$tag\">"
				."<input type=hidden name=\"V$section$tvcnt\" value=\"$val\">\n";
		}
	}
	$tvcnt++;
	if ($vars{"sect"} eq $section){
		print <<EOM;
<script language="JavaScript"><!--
function check_new(form){
	if (form.T$section$tvcnt.value == "New $coltitles->{$section}{'left'}"){
		form.T$section$tvcnt.value ="";
	};
	if (form.V$section$tvcnt.value == "New $coltitles->{$section}{'right'}"){
		form.V$section$tvcnt.value ="";
	};
	return true;
};
function clear_input(Input,Test){
	if (Input.value == Test){
		Input.value ="";
	}
};
--></script>
EOM

		if ($section ne "moh"){
			print "<tr class=\"TableTextAlt\"><td  align=right><input  type=text name=\"T$section$tvcnt\" value=\"New $coltitles->{$section}{'left'}\""
				." onbeforeeditfocus=\"clear_input(this,'New $coltitles->{$section}{'left'}')\"></td>"
				."<td >=</td>"
				."<td  align=left><input  type=text name=\"V$section$tvcnt\" value=\"New $coltitles->{$section}{'right'}\""
				." onbeforeeditfocus=\"clear_input(this,'New $coltitles->{$section}{'right'}')\"></td></tr>\n";
			print "<tr class=\"TableTextAlt\"><td colspan=3>&nbsp;</td></tr>\n";
		}
		else {
			my $mycnt=$tvcnt-1;
			print "<tr class=\"TableTextAlt\"><input  type=hidden name=\"T$section$tvcnt\" value=\"moh$mycnt\">"
				."<td  align=center><input  type=text name=\"V$section$tvcnt\" value=\"New $coltitles->{$section}{'right'}\""
				." onbeforeeditfocus=\"clear_input(this,'New $coltitles->{$section}{'right'}')\"></td></tr>\n";
			print "<tr class=\"TableTextAlt\"><td colspan=2>&nbsp;</td></tr>\n";
		}
		print "</table>\n";
	}
}
print "</td></tr>\n";
print "</table>\n";
print $q->submit(-value=>"Save");
print "</div>\n";
print $q->end_form;
print $q->end_html;


sub getconf($){
	my $file = shift;
	my ($line,$section,$tag,$value,$config);
	open(FILE,"< $file") || doerr "Can't open $file : $!\n";
	foreach $line (<FILE>){
		chomp $line;
		if ($line =~ /^\s*#/){
			next;
		}
		elsif($line =~ /^\s*\[\w+\]/){
			$section=$line;
			$section =~ s/[\[\]]//g;
		}
		#elsif($line =~ /(\w+)=(\w+)/){
		elsif($line =~ /\w+=.+/){
			($tag, @value)= split /=/,$line;
			$config->{$section}{$tag} = "@value";
		}
#		else {
#			print "<pre> $line </pre>\n";
#		}
	}
	close FILE;
	return($config);
}

sub writeconf($$){
	my ($file,$config)=@_;
	open(FILE,"> $file") || doerr "Can't open $file : $!\n";
	foreach $section (keys %{$config}){
		print FILE "[$section]\n";
		foreach $tag (sort {$a <=> $b} (keys %{$config->{$section}})){
			$tvcnt++;
			my $val=$config->{$section}->{$tag};
			print FILE "$tag=$val\n";
		}
		$tvcnt++;
		print FILE "\n";
	}
	return;
}

sub doerr($){
	print "$_";
	print $q->end_form;
	print $q->end_html;
	exit;
}
